/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.JenisAlamat;
import com.portofolio.entity.vo.JenisAlamatId;

@Lazy
@Repository
public interface JenisAlamatDao extends CrudRepository<JenisAlamat, JenisAlamatId> {


    @Query(QListAll)
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.namaJenisAlamat like %:namaJenisAlamat% ")
    Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaJenisAlamat") String namaJenisAlamat,@Param("statusEnabled") boolean statusEnabled, Pageable page);
    
    @Query(QListAll + " and model.id.kdJenisAlamat=:kdJenisAlamat")
    Map<String, Object> findByKdJenisAlamat(@Param("kdProfile") Integer kdProfile, @Param("kdJenisAlamat") Integer kode,@Param("statusEnabled") boolean statusEnabled);
    
    String QListAll ="select new map(model.id.kdJenisAlamat as kdJenisAlamat,model.id.kdProfile as kdProfile "
            + ", model.namaJenisAlamat as namaJenisAlamat " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from JenisAlamat model left join model.id id  where id.kdProfile=:kdProfile and model.statusEnabled=:statusEnabled  "; 

}
